
#ifndef __FP_STDIO
#define __FP_STDIO
#define __FP_BUILTIN

#define __need_size_t
#include <stddef.h>

struct _IO_FILE{
    int fd;
};
typedef struct _IO_FILE FILE;
typedef struct{
    int t;
}_G_fpos_t;
typedef _G_fpos_t fpos_t;

#ifndef NULL
static void* NULL;

#define	_IOFBF	0		/* setvbuf should set fully buffered */
#define	_IOLBF	1		/* setvbuf should set line buffered */
#define	_IONBF	2		/* setvbuf should set unbuffered */


#endif
#ifndef EOF
static int EOF;
#endif
static FILE* stdin;
static FILE* stdout;
static FILE* stderr;

#ifndef SEEK_SET
#define	SEEK_SET	0	/* set file offset to offset */
#endif
#ifndef SEEK_CUR
#define	SEEK_CUR	1	/* set file offset to current plus offset */
#endif
#ifndef SEEK_END
#define	SEEK_END	2	/* set file offset to EOF plus offset */
#endif

extern int printf(const char *format, ...);
extern int fprintf(FILE *stream, const char *format, ...);
extern int sprintf(char *s, const char *format, ...);
#ifndef __FP_BUILTIN
typedef void* va_list;
extern int vfprintf(FILE *stream, const char *format, va_list arg);
extern int vsprintf(char *s, const char *format, va_list arg);
extern int vprintf(const char *format, va_list arg);
#endif
extern int scanf(const char *format, ...);
extern int fscanf(FILE *stream, const char *format, ...);
extern int sscanf(char *s, const char *format, ...);
extern int puts(const char *s);
extern int fputs(int c, FILE *stream);
extern char *gets(char *s);
extern char *fgets(char *s, int n, FILE *stream);
extern int putchar(int c);
extern int getchar(void);
extern int fputc(int c, FILE *stream);
extern int putc(int c, FILE *stream);
extern int fgetc(FILE *stream);
extern int getc(FILE *stream);
extern int ungetc(int c, FILE *stream);
extern FILE *fopen(const char *filename, const char *mode);
extern FILE *freopen(const char *filename, const char *mode, FILE *stream);
extern int fclose(FILE *stream);
extern size_t fread(void *ptr, size_t size, size_t nobj, FILE *stream);
extern size_t fwrite(const void *ptr, size_t size, size_t nobj, FILE *stream);
extern int fseek(FILE *stream, long offset, int origin);
extern long ftell(FILE *stream);
extern void rewind(FILE *stream);
extern int fgetpos(FILE *stream, fpos_t *ptr);
extern int fsetpos(FILE *stream, const fpos_t *ptr);
extern int fflush(FILE *stream);
extern int remove(const char *filename);
extern int rename(const char *oldname, const char *newname);
extern FILE *tmpfile(void);
extern char *tmpnam(char s[]);
extern int setvbuf(FILE *stream, char *buf, int mode, size_t size);
extern void setbuf(FILE *stream, char *buf);
extern void setbuffer(FILE *stream, char *buf, int size);
extern void clearerr(FILE *stream);
extern int feof(FILE *stream);
extern int ferror(FILE *stream);
extern void perror(const char *s);

#endif

